/* Create Procedure SQLINOUTRS1 (INOUT parm1 CHAR(10), OUT parm2 CHAR(10), parm3 INOUT DEC(8,2) ) 
        RESULT SET 1 LANGUAGE SQL 
        BEGIN
          DECLARE C1 CURSOR FOR SELECT * FROM QIWS.QCUSTCDT;
          SET parm2 = parm1;
          SET parm1 = '1234567890';
          SET parm3 = parm3 + 1;
          OPEN C1;         
          SET RESULT SETS CURSOR C1;
          end
*/
/************************************************************************/
/*                       LICENSE AND DISCLAIMER					                */
/*                                                              		    */
/* This material contains IBM copyrighted sample programming source	    */
/* code for your consideration.  This sample code has not been		      */
/* thoroughly tested under all conditions.  IBM, therefore, cannot	    */
/* guarantee or imply reliability, serviceability, or function.		      */
/* IBM provides no program services for this material. This material	  */
/* is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR	*/
/* IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	  */
/* FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME		      */
/* JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO	  */
/* THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM	    */
/* BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER  	*/
/* CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,		    */
/* WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS    */
/* OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR	    */
/* OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH	    */
/* DAMAGES.


                          COPYRIGHT                              		    */
/*                              ---------                              	*/
/*               (C) Copyright IBM CORP. 1998, 1999                   	*/
/*               All rights reserved.                                  	*/
/*               US Government Users Restricted Rights -               	*/
/*               Use, duplication or disclosure restricted             	*/
/*               by GSA ADP Schedule Contract with IBM Corp.           	*/
/*               Licensed Material - Property of IBM                   	*/
/*******************************************************************
*
* Module:
*   DBSMQRYF.C
*
* Purpose:
*     This is a sample program. It shows the basics of how to use
*     the Client Access/400 Optimized SQL APIs to query a DB table.
*     It takes a system name as a parameter and prompts for the 
*     collection and table name.
*
*******************************************************************/


//#define CWB_ANSI_ONLY
//#define CWB_ANSI


#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "CWBDB.H"
#include "CWBSV.H"
#include "cwbdt.h"
#include "DBSMDSPS.H"

#include "CWBNLCNV.H"    /* cwbNL_GetANSICodePage   */

#define SYSLEN  14       /* Maximum system name is 14 plus the null char  */
#define LIBLEN  11       /* Maximum library name is 10 plus the null char */
#define PKGLEN  11       /* Maximum SQL package name is 10 plus null char. */
#define FILELEN 11       /* Maximum file name is 10 plus null char. */

/* Cycles through the parameter markers, calling displayParameterInfo */
/* for each parameter marker and changing packed and zoned numeric    */
/* parameters to PC long variables.                                   */
unsigned int workWithParameterMarkers( cwbDB_FormatHandle pmDataFormat );


/* This routine is used to acquire data for upload. */
void readData( char *dataBlock,      unsigned long rowSize,
               char *indicatorBlock, unsigned long nbrParms );


void verbose( char * myString );


int main(int argc, char *argv[])
{

  cwbDB_ConnectionHandle connectionHandle;   /* Handle to enable connect     */
  cwbDB_RequestHandle    sqlRequestHandle;   /* Handle to enable SQL reqs    */
  cwbDB_DataHandle       hostMsgID;          /* Host message identifier.     */
                                             /*   Just identifies the error  */
  cwbDB_DataHandle       firstLevelMessage;  /* First level message text.    */
                                             /*   This is the short text.    */
  cwbDB_DataHandle       secondLevelMessage; /* Second level message text.   */
                                             /*   This is the long text.     */
  cwbDB_DataHandle       dataBuffer;         /* Handle to buffer of data     */
  cwbDB_FormatHandle     dataFormat;         /* Handle to format of data     */
  cwbDB_DataHandle       indicatorsBuffer;   /* Buffer of null indicators    */
  //DXD
  cwbDB_FormatHandle     pmDataFormat;       /* Data format handle for       */
                                             /* parameter marker data.       */
  unsigned long          parmLength = 0,     /* parameter marker length          */
                         nbrParms = 0;       /* number of parameter markers      */
  unsigned short         parmPrecision = 0,  /* parameter marker precision       */
                         parmScale = 0;      /* parameter marker scale           */
  char                   *parmDataBlock;     /* pointer to data buffer           */
  char                   *parmIndicatorBlock;/* pointer to null indicator buffer */
  unsigned short		 *parmIndicatorPtr;
  cwbDB_SQLCA				 sqlca;
  long					 cResults;
  char					 szDec[12];
  //
  cwbSV_ErrHandle        msgHandle;          /* Handle to PC messages        */
  char                   sysname[SYSLEN],    /* Space for AS/400 system name */
                         *sysptr;            /* Ptr to AS/400 system name    */
  unsigned int           rc = 0, newRC = 0;  /* return codes                 */
  unsigned short         hostErrorClass = 0; /* Class of host error          */
  signed long            hostErrorCode = 0;  /* Host error code              */
  char                   tableName[10];      /* Space for name of SQL table  */
  char                   collectionName[10]; /* Space for name of collection */
  char                   bigStmt[200];       /* Space for SELECT statement   */
  unsigned long          columnCount = 0,    /* Number of returned columns   */
                         blockCount = 2,     /* Number of rows per fetch (read only) */
                         rowSize = 0,        /* Size of a result row of data */
						 ansiCCSID = 0,
                         j = 0;              /* Amusing little integers      */
  int                    i = 0,
                         k = 0,
                         x = 0;

  /* Check on the command line parameters. Expect an AS/400 system name only */
  /* Might get something else or a help request.                             */
    if ( argc < 2 )
    { displayUsage( argv[0] ); return(-1); }
    else
    {
      /* Did user request help? */
      if (*argv[1] == '?' || !strncmp(argv[1], "-h", 2) )
      {
        displayUsage( argv[0] );
        return(-1);
      }
      else { sysptr = argv[1]; } /* Assume system name given. */
    }

    /* Copy system name from ARGV to local variable  */
    strncpy(sysname, sysptr, SYSLEN); 

    /* Create PC error message handle. This handle is used by the API layer      */
    /* to log serviceability messages.                                           */
    verbose(">>> Create error handle. \n");
    rc = cwbSV_CreateErrHandle( &msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbSV_CreateErrHandle(): Service API failed ");
        printf("with return code %d.\n", rc);
        return(rc);
    }

    /********************************************************************/
    /* Create 3 data handles used for returning host error information. */
    /********************************************************************/

    /* Create a data handle for the HOST MESSAGE ID.                    */
    verbose(">>> Create a data handle for the host message id. \n");
    rc = cwbDB_CreateDataHandle( &hostMsgID, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataHandle failed with return code %d.\n", rc);
        return(rc);
    }

    /* Create a data handle for the FIRST LEVEL MESSAGE TEXT. */
    verbose(">>> Create a data handle for the first level message text. \n");
    rc = cwbDB_CreateDataHandle( &firstLevelMessage, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataHandle failed with return code %d.\n", rc);
        return(rc);
    }

    /* Create a data handle for the SECOND LEVEL MESSAGE TEXT. */
    verbose(">>> Create a data handle for the second level message text. \n");
    rc = cwbDB_CreateDataHandle( &secondLevelMessage, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataHandle failed with return code %d.\n", rc);
        return(rc);
    }

    /********************************************************************/
    /* Create 2 data handles used for returning data.                   */
    /********************************************************************/

    /* Create a data handle for the DATA.                               */
    verbose(">>> Create a data handle for the data. \n");
    rc = cwbDB_CreateDataHandle( &dataBuffer, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataHandle failed with return code %d.\n", rc);
        return(rc);
    }

    /* Create a data handle for the null INDICATORS.                    */
    /*     If a field is NULL CAPABLE, and the value for that field in  */
    /*     a given row IS null, then the indicator will reflect that!   */
    verbose(">>> Create a data handle for the indicators. \n");
    rc = cwbDB_CreateDataHandle( &indicatorsBuffer, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataHandle failed with return code %d.\n", rc);
        return(rc);
    }


    /********************************************************************/
    /* Create a handle to enable connection to the AS/400. SQL requests */
    /* and data formats will be tied to a single connection handle.     */
    /*     Think of the connection handle as a collection of associated */
    /*     requests and data formats.                                   */
    /********************************************************************/

    /* Create connection handle to the AS/400 system using the system   */
    /* name passed in to this program.                                  */
    verbose(">>> Create connection handle to the AS/400 system. \n");
    printf("\nCreating connection handle to %s . . .\n", sysptr);
    rc = cwbDB_CreateConnectionHandle( sysptr, &connectionHandle, msgHandle );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateConnectionHandle failed with ");
        printf("return code %d.\n", rc);
        return(rc);
    }

	//*********** Lob support *************************************
	//Sets the size at which a locator is returned for lobs rather then
	//the actual lob data.  To optimize performance  set this 
	//to the maximum lob size if you always plan to fetch the lob data.
	//If the lob data may not be fetched (depending on user input or
	//other factors) or is fetched in a background thread while
	//the other data is displayed then consider setting this to a lower value.  
	//The lobthreshold is based off the lob field size and not the
	//size of the actual data.
	//
	rc = cwbDB_SetLOBFieldThreshold( 
									connectionHandle,
									16384,		// 0 to 16384 thresholdSize, 
									msgHandle); 
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_SetLOBFieldThreshold failed with ");
        printf("return code %d.\n", rc);
    }


    /********************************************************************/
    /* Now that we have a connection handle, we can start a connection  */
    /* with the AS/400 database server.                                 */
    /********************************************************************/

    /* Start communication between the client and the AS/400.            */
    verbose(">>> Start communcation between the client and the AS/400. \n");
    printf("\nAttempting to start the server . . .\n");
    rc = cwbDB_StartServer( connectionHandle, msgHandle );

    if (rc  == CWBDB_CANNOT_CONTACT_SERVER )
    {
        printf("\ncwbDB_StartServer failed with return code %d.\n", rc );
        return(rc);
    }
    else
    {
      if ( rc != CWB_OK )
         printf("\ncwbDB_StartServer returned a warning: %d\n", rc );
    }


    /********************************************************************/
    /* Now that we have a connection handle, we can create the request  */
    /* handles and data format handles which will be associated with it.*/
    /********************************************************************/

    /* Create SQL request handle for the subsequent APIs that request SQL */
    verbose(">>> Create SQL request handle for the subsequent APIs that request SQL \n");
    /* operations to be performed.                                        */
    rc = cwbDB_CreateSQLRequestHandle( connectionHandle,
                                       &sqlRequestHandle,
                                       msgHandle         );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateSQLRequestHandle failed ");
        printf("with return code %d.\n", rc);
        return(rc);
    }

    /********************************************************************/
    /* The data format provides a way of describing the data returned   */
    /* from the AS/400. It has information about each column such as    */
    /* the column data type, the column data length, the column name... */
    /* The data format also has information about a row of data such    */
    /* as the size of a row of data.                                    */
    /********************************************************************/

    /* Create data format handle for the subsequent APIs that request SQL */
    verbose(">>> Create data format handle for the subsequent APIs that request SQL \n");
    /* operations to be performed.                                        */
    rc = cwbDB_CreateDataFormatHandle( connectionHandle,
                                       &dataFormat,
                                       msgHandle         );
    if (rc != CWB_OK)
    {
        printf("\ncwbDB_CreateDataFormatHandle failed ");
        printf("with return code %d.\n", rc);
        return(rc);
    }

	/********************************************************************/
	/*dxd Here we are creating the parameter marker data format handle.    */
	/********************************************************************/
	rc = cwbDB_CreateParameterMarkerFormatHandle( connectionHandle,
		                                            &pmDataFormat,
			                                        msgHandle        );
	if (rc != CWB_OK)
	{
		printf("\ncwbDB_CreateParameterMarkerFormatHandle failed with return code %d.\n", rc);
		return(rc);
	}


    /********************************************************************/
    /* Everything so far has been set-up for what follows.              */
    /********************************************************************/

    /********************************************************************/
    /* Part of the 'philosophy' of the optimized SQL APIs is that       */
    /* nothing is returned from the AS/400 unless it is requested by    */
    /* the client. This reduces communications traffic in order to      */
    /* improve performance. In order to request data from the AS/400,   */
    /* call one of the cwbDB_Return...... APIs to request the data      */
    /* and then perform a function (verb) such as cwbDB_Prepare, or     */
    /* call cwbdb_GetData.                                              */
    /********************************************************************/

     
     strcpy(bigStmt, "CALL SQLINOUTRS1(?, ?, ?)");

     rc = cwbNL_GetANSICodePage( &ansiCCSID, 0 );

     rc = cwbDB_SetClientInputCCSID( connectionHandle,
		                             (unsigned short) ansiCCSID ,
                                     0 );

    /********************************************************************/
    /* In order to retrieve the data from the collection/table, we have */
    /* to first PREPARE (sort-of compile) the statement. We'll also     */
    /* DESCRIBE the data in order to get information about the columns  */
    /* (fields) in the data we've selected.                             */
    /********************************************************************/

    /********************************************************************/
    /* There are three parameters which MUST be set prior to doing      */
    /* the PREPARE step:                                                */
    /*   statement text (SELECT * FROM COLLECTION/TABLE)                */
    /*   statement name (arbitrary up to 18 character name)             */
    /*                  The database server uses the statement name     */
    /*                  during the PREPARE function in one of its       */
    /*                  optimization steps.                             */
    /*   cursor name    (arbitrary up to 18 character name)             */
    /*                  Think of the cursor as a pointer in the         */
    /*                  database table which points at a row of data.   */
    /********************************************************************/
     verbose(">>> Set statement text \n");
     rc = cwbDB_SetStatementName( sqlRequestHandle,
                                  "DBSMQRYF01",   // Up to 18 characters long
                                  msgHandle         );
     if (rc != CWB_OK)
     {
         printf("\ncwbDB_SetStatementName failed ");
         printf("with return code %d.\n", rc);
         return(rc);
     }

     verbose(">>> Set cursor name \n");
     rc = cwbDB_SetCursorName( sqlRequestHandle,
                               "DBSMQRYF01",  // Up to 18 characters long
                               msgHandle         );
     if (rc != CWB_OK)
     {
         printf("\ncwbDB_SetCursorName failed ");
         printf("with return code %d.\n", rc);
         return(rc);
     }


     verbose(">>> Set statement text \n");
     rc = cwbDB_SetStatementText( sqlRequestHandle,
                                  bigStmt,   // SELECT Statement built above.
                                  msgHandle         );
     if (rc != CWB_OK)
     {
         printf("\ncwbDB_SetStatementText failed ");
         printf("with return code %d.\n", rc);
         return(rc);
     }

	//dxd
    /********************************************************************/
    /* Store the parameters in the SQL request parameter block on the   */
    /* AS/400. That way we can reuse the values later without flowing   */
    /* them to the AS/400 again.                                        */
    /********************************************************************/
     verbose(">>> Store the parameters in the SQL RPB \n");
     rc = cwbDB_StoreRequestParameters( sqlRequestHandle,
                                        msgHandle         );
     if (rc != CWB_OK)
     {
         displayErrors( "cwbDB_StoreRequestParameters",
                        rc,        hostErrorClass,    hostErrorCode,
                        hostMsgID, firstLevelMessage, secondLevelMessage );
         return(rc);
     }
	// That sends the create RPB flow


	//dxd  Now work on the prepare/describe flow 
	verbose(">>> Ask for the PM data format to be returned. \n");
	rc =  cwbDB_ReturnParameterMarkerFormat( sqlRequestHandle,
		                                       pmDataFormat,
			                                   msgHandle          );
	if (rc != CWB_OK)
	{
		printf("\ncwbDB_ReturnParameterMarkerFormat failed with return code %d.\n", rc);
		return(rc);
	}
	
	//Since the 400 allows the result set to change at execute you can't
	//describe the result data yet.  No point in sending RetrunDataFormat
	
    /********************************************************************/
    verbose(">>> Ask for the host info to be returned. \n");
    rc =  cwbDB_ReturnHostErrorInfo( sqlRequestHandle,
                                     &hostErrorClass,
                                     &hostErrorCode,
                                     hostMsgID,
                                     firstLevelMessage,
                                     secondLevelMessage,
                                     msgHandle                );


    /********************************************************************/
    /* PREPARE and DESCRIBE the SQL statement.                          */
    /*   The PREPARE function causes the AS/400 to check the syntax of  */
    /*   the SQL statement (the text we set above) and if it parses OK  */
    /*   to build any necessary data structures it will need later to   */
    /*   access the actual database table.                              */
    /*                                                                  */
    /*   The DESCRIBE function takes the PREPAREd statement and builds  */
    /*   a description of the data which will be returned from the      */
    /*   AS/400.                                                        */
    /*                                                                  */
    /*   In order to improve performance, these two operations have     */
    /*   been combined into a sinlge API to reduce communications       */
    /*   traffic between the client and the AS/400. There are other     */
    /*   combinations which can be useful to more advanced programs but */
    /*   we'll break things down a little and talk about things as we   */
    /*   go along.                                                      */
    /********************************************************************/
     verbose(">>> PrepareDescribe the  statement \n");
     rc = cwbDB_PrepareDescribe( sqlRequestHandle,
                                 msgHandle         );
     if ( rc != CWB_OK )
     {
         displayErrors( "cwbDB_PrepareDescribe",
                        rc,        hostErrorClass,    hostErrorCode,
                        hostMsgID, firstLevelMessage, secondLevelMessage );
         return(rc);
     }

	//DXD  You can now access and set the parameter data....
	/*********************************************************************/
	/* Find out how many parameter markers there were in the INSERT      */
	  /* statement. For this exercise, it will return 3. The ? before the  */
	  /* ROWS clause is not included in this count.                        */
	  /*********************************************************************/
	  rc = cwbDB_GetParameterCount( pmDataFormat,  (unsigned long*)&nbrParms,
									msgHandle     );
	  if ( rc != CWB_OK )
	  { return(rc); }

	  /***************************************************************/
	  /* This next call is to display info about each parameter      */
	  /* and change packed or zoned numerics to a more PC            */
	  /* friendly format.                                            */
	  /* It's not necessary to the operation of the upload, just     */
	  /* an interesting aside.                                       */
	  /***************************************************************/
	  //rc = workWithParameterMarkers( pmDataFormat );

	  //For better performance convert the string data with cwbNL
	  //Create one converter then use it to convert the data.
	  //For now we'll set the param to ascii to make the host convert it.
	  //
	  rc = cwbDB_SetClientParameterToString( pmDataFormat,
                                         1,
                                         CWBDB_PCSTRING,
                                         10,
                                         437,
                                         0 );
	  rc = cwbDB_SetClientParameterToString( pmDataFormat,
                                         2,
                                         CWBDB_PCSTRING,
                                         10,
                                         437,
                                         0 );

    /* Get the length of one row of input */
    rc = cwbDB_GetSizeOfParameters( pmDataFormat,   
												&parmLength, msgHandle     );
    if ( rc != CWB_OK )
    {
      printf( "\ncwbDB_GetSizeOfInputParameters failed with return code: %d \n", rc );
      return(rc);
    }

    parmDataBlock = (char *) malloc( parmLength );
    memset( parmDataBlock,0,parmLength);
    parmIndicatorBlock = (char*) malloc( nbrParms * 2 );
    memset( parmIndicatorBlock,0,nbrParms * 2);	//Init to non-null
	//Set the input data
   	memcpy(parmDataBlock, "9876543210", 10);	//parm 1 input/output
	cwbDT_ASCIIToPacked( parmDataBlock + 20, "123456.78", 5, 2); //parm3 input/output
	//Not needed unless we pass a null
    //parmIndicatorPtr = (unsigned short*) parmIndicatorBlock;                     
    //for ( j = 0; j < nbrParms; j++ )                                  
    //{                                                                 
    //    *parmIndicatorPtr = 0;                                            
    //    parmIndicatorPtr ++;                                            
    //}                                                                 


    /* Set      the block of data */
    verbose(">>> Set parameter marker block\n");
    rc = cwbDB_SetParameterMarkers( sqlRequestHandle,
                                    //    1,						//1 row
                                        pmDataFormat,
                                        (void*)parmDataBlock, // NULL,
                                        (signed short *)parmIndicatorBlock,
                                        msgHandle );

    if (rc != CWB_OK)
    {
        printf("\ncwbDB_SetParameterMarkerBlock failed. rc: %d ",rc);
        return(rc);
    }

	//Need SQL CA to see how many result sets are returned.
	rc = cwbDB_ReturnSQLCA(sqlRequestHandle,	// Request handle
				           &sqlca,				// SQLCA structure
				           0);					// No error handle here

    /* Ask for the parameter data to be returned. */
    verbose(">>> Ask for the data to be returned. \n");
    rc =  cwbDB_ReturnData( sqlRequestHandle,
                               dataBuffer,
                               indicatorsBuffer,
                               pmDataFormat,
                               msgHandle   );


	 //DXD  Now execute the procedure
     rc = cwbDB_Execute( sqlRequestHandle,
                                 msgHandle         );
	 //THis will return 0100C  x results returned message in R510 and later....
	 if (rc != CWB_OK)
	 {
		 //dxd Since I didn't ask for the error message (to save flowing a few bytes
		 //I have to ask for it now....
 		cwbDB_ReturnHostErrorInfo(sqlRequestHandle, &hostErrorClass, &hostErrorCode,
			hostMsgID, firstLevelMessage, secondLevelMessage, 0); 
		cwbDB_GetData(sqlRequestHandle, msgHandle);
        displayErrors( "cwbDB_PrepareDescribe",
                        rc,        hostErrorClass,    hostErrorCode,
                        hostMsgID, firstLevelMessage, secondLevelMessage );
		if ( !( rc == CWB_OK || rc == CWBDB_SQL_WARNING || 
			rc == CWBDB_SQL_PARAMETER_WARNING  ))
		{
		     return(rc);
		}
	 }

	 //DXD Now access the output parameter data
	 cwbDB_GetDataPointer(dataBuffer, &parmDataBlock, 0);
	 cwbDB_GetDataPointer(indicatorsBuffer, &parmIndicatorBlock, 0);
	printf("parm1: %10.10s \n", parmDataBlock);
	printf("parm2: %10.10s \n", (parmDataBlock += 10) );		//Should use size of parm1...
	memset(szDec, 0, sizeof(szDec));
	cwbDT_PackedToASCII(szDec, (parmDataBlock += 10), 5, 2);
	printf("parm3: %s \n", szDec);		//Should use size of parm2...
	 
	 //DXD  Now open/describe the result set...
	 cResults = sqlca.sqlerrd[1];
	 printf("Number of result sets %d \n", cResults);

     verbose(">>> Ask for the data format to be returned. \n");
     rc =  cwbDB_ReturnDataFormat( sqlRequestHandle,
                                      dataFormat,
                                      msgHandle                );

	//Could add this and use OpenDescribeFetch to save a round trip (i.e. "prefetch") 
    //rc =  cwbDB_ReturnData( sqlRequestHandle,
    //                           dataBuffer,
    //                           indicatorsBuffer,
    //                           dataFormat,
    //                           msgHandle   );	

     rc = cwbDB_Open( sqlRequestHandle, CWBDB_READ,
                                 msgHandle         );
     if ( rc != CWB_OK )
     {
		 //dxd Since I didn't ask for the error message (to save flowing a few bytes
		 //I have to ask for it now....
 		cwbDB_ReturnHostErrorInfo(sqlRequestHandle, &hostErrorClass, &hostErrorCode,
				hostMsgID, firstLevelMessage, secondLevelMessage, 0) ;
		cwbDB_GetData(sqlRequestHandle, msgHandle);

         displayErrors( "cwbDB_OpenDescribeFetch",
                        rc,        hostErrorClass,    hostErrorCode,
                        hostMsgID, firstLevelMessage, secondLevelMessage );
         return(rc);
     }



    /********************************************************************/
    /* Now that we've got the data format describing the data, we can   */
    /* display some interesting facts about the data to impress our     */
    /* friends!                                                         */
    /********************************************************************/
    /* Display the number of columns.                                   */
    /********************************************************************/
     rc = cwbDB_GetColumnCount( dataFormat, &columnCount, msgHandle );
     printf("Number of columns in results: %ld\n", columnCount );

    /********************************************************************/
    /* Display the size of a row of data.                               */
    /********************************************************************/
     rc = cwbDB_GetRowSize( dataFormat, CWBDB_LOCAL, &rowSize, msgHandle );
     printf("Row size: %ld\n", rowSize );

    /********************************************************************/
    i = 0;  // Increment each time we fetch a block from the AS/400
    while ( rc == CWB_OK )
    {
       printf("."); // Indicates activity during FETCH operations

       /********************************************************************/
       /* Tell the AS/400 DB server to send down a block of records at one */
       /* time.                                                            */
       /********************************************************************/
       rc = cwbDB_SetBlockCount( sqlRequestHandle, blockCount, msgHandle );
       if (rc != CWB_OK)
       {
         printf("\ncwbDB_SetBlockCount failed ");
         printf("with return code %d.\n", rc);
         return(rc);
       }
   
       /********************************************************************/
       /* Ask for the host error info to be returned.                      */
       /********************************************************************/
       /* Ask for the host info to be returned. */
       verbose(">>> Ask for the host info to be returned. \n");
       rc =  cwbDB_ReturnHostErrorInfo( sqlRequestHandle,
                                        &hostErrorClass,
                                        &hostErrorCode,
                                        hostMsgID,
                                        firstLevelMessage,
                                        secondLevelMessage,
                                        msgHandle                );

       /********************************************************************/
       /* Ask for the data to be returned.                                 */
       /* NULL capable columns which are null will have an INDICATOR set   */
       /* to indicate that the field is null. If a field is null, the      */
       /* data in the field is undefined.                                  */
       /********************************************************************/
       /* Ask for the data to be returned. */
       verbose(">>> Ask for the data to be returned. \n");
       rc =  cwbDB_ReturnData( sqlRequestHandle,
                               dataBuffer,
                               indicatorsBuffer,
                               dataFormat,
                               msgHandle   );

       /* Fetch the data. It will be returned to the PC because we */
       /* just asked for it!                                       */
       verbose(">>> Fetch the data from the SELECT statement \n");
       rc = cwbDB_Fetch( sqlRequestHandle, msgHandle );
	   /* Note: this warning just indicates there was not enough data   */
	   /* to fill the block, although some of the block was filled      */
	   if(rc == CWBDB_SQL_PARAMETER_WARNING
		      && hostErrorClass == 2 && hostErrorCode == 701)
			rc = CWB_OK;
       if ( rc != CWB_OK)
       {

         if ( ( ( hostErrorClass == 1 )
             && ( hostErrorCode == 100 ) ) )
         {
			 //dxd could be partial block?
           printf("\n\nLast chunk of data received.\n");
         }
         else
         {
              displayErrors( "cwbDB_Fetch",
                             rc,        hostErrorClass,    hostErrorCode,
                            hostMsgID, firstLevelMessage, secondLevelMessage );
              return(rc);
         }
        
       }
       else
       {
         displayData( dataBuffer, dataFormat,  indicatorsBuffer,  msgHandle,
						sqlRequestHandle); //Lob's require the stmt handle 
		 i++; // Increment each time we fetch a block from the AS/400
       }

   } // end_while

printf("\nFetch complete. %d chunks fetched.\n",i);


/* End communications between the client and the AS/400. */
verbose(">>> End communications between the client and the AS/400. \n");
printf("\nEnding the server . . .");
if ((rc = cwbDB_StopServer(connectionHandle, msgHandle)) != CWB_OK)
{
   printf("\ncwbDB_StopServer failed with return code %d.\n", rc);
   return(rc);
}


return(rc);

} /* end of main */

/************************************************************************/
/************************************************************************/

void verbose( char * myString )
{
#if defined(VERBOSE)
  printf("%s",myString);
#endif
}

/************************************************************************/
/************************************************************************/
/* A routine to "read" data in from a file. For simplicity, it just     */
/* creates a little data on its own.                                    */
/************************************************************************/
void readData( char *dataBlock,      unsigned long rowSize,
               char *indicatorBlock, unsigned long nbrParms )

{

    
} /* end readData */





