/************************************************************************/
/*                       LICENSE AND DISCLAIMER					                */
/*                                                              		    */
/* This material contains IBM copyrighted sample programming source	    */
/* code for your consideration.  This sample code has not been		      */
/* thoroughly tested under all conditions.  IBM, therefore, cannot	    */
/* guarantee or imply reliability, serviceability, or function.		      */
/* IBM provides no program services for this material. This material	  */
/* is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR	*/
/* IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	  */
/* FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME		      */
/* JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO	  */
/* THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM	    */
/* BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER  	*/
/* CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,		    */
/* WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS    */
/* OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR	    */
/* OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH	    */
/* DAMAGES.


                          COPYRIGHT                              		    */
/*                              ---------                              	*/
/*               (C) Copyright IBM CORP. 1998, 1999                   	*/
/*               All rights reserved.                                  	*/
/*               US Government Users Restricted Rights -               	*/
/*               Use, duplication or disclosure restricted             	*/
/*               by GSA ADP Schedule Contract with IBM Corp.           	*/
/*               Licensed Material - Property of IBM                   	*/
/*******************************************************************
/*******************************************************************
*
* Module:
*   DBSMDSPS.H
*
* Purpose:
*      Header file for the utility routines for the DB sample programs to use.
*
*******************************************************************/

#if !defined(dbsmdsps_h)
#define dbsmdsps_h

#define SYSLEN  14       /* Maximum system name is 14 plus the null char  */
#define LIBLEN  11       /* Maximum library name is 10 plus the null char */
#define PKGLEN  11       /* Maximum SQL package name is 10 plus null char. */
#define FILELEN 11       /* Maximum file name is 10 plus null char. */

void displayErrors( char *            APIcall,
                    unsigned int      rcode,
                    unsigned short    errorClass,
                    signed long       errorCode,
                    cwbDB_DataHandle  msgID,
                    cwbDB_DataHandle  firstText,
                    cwbDB_DataHandle  secondText );

/************************************************************************/
void displayMessages( cwbDB_DataHandle  msgID,
                      cwbDB_DataHandle  firstText,
                      cwbDB_DataHandle  secondText );

/************************************************************************/
void displayClientError( unsigned int  clientRC );
void displayBaseClientError( unsigned int  clientRC );

/************************************************************************/
int displayData( cwbDB_DataHandle    data,
                  cwbDB_FormatHandle  dataFormat,
                  cwbDB_DataHandle    indicators,
                  cwbSV_ErrHandle     errHandle    
				  ,cwbDB_DataHandle	sqlRequestHandle 	//Required for LOBs
				);
/************************************************************************/
void displayUsage(  char *myName  );

/************************************************************************/

void displayParameterInfo( int           parmNbr,
                           signed short  parmType,
                           unsigned long parmLen  );


/************************************************************************/

// unsigned int processConversionErrors( cwbDB_DataHandle indicators,
//                                       unsigned int     rowPosition,
//                                       unsigned int     columnCount );
//

/************************************************************************/
/* A routine to cause data to be returned from the AS/400 in ANSI       */
/* instead of OEM.                                                      */
/*    Call it after calling:                                            */
/*          cwbDB_Prepare + cwbDB_Describe + cwbDB_ReturnDataFormat     */
/*                        ----- OR -----                                */
/*            cwbDB_PrepareDescribe + cwbDB_ReturnDataFormat            */
/*    and before:  cwbDB_Fetch                                          */
/************************************************************************/
unsigned int causeANSIConversion( cwbDB_FormatHandle dataFormat );


#endif
